package swingcolorgame;

import java.util.Random;


class SwingColorLogic {

    private int[][] colors;

    public SwingColorLogic(int width, int height) {
        if(width > 0 && height > 0){
            colors = new int[width][height];
        } else {
            throw new IllegalArgumentException();
        }
        newGame();
        
    }
      
    public int getWidth(){
        return colors.length;
    } 
    
    public int getHeight(){
        return colors[0].length;
    }

    public final void newGame() {
        Random random = new Random();
        for (int i = 0; i < getWidth(); i++) {
            for (int j = 0; j < getHeight(); j++) {
                colors[i][j] = random.nextInt(3);
            }
        }
    }
    
    public int getCellColor(int i, int j){
        return colors[i][j];
    }
    
    public void changeCellColor(int i, int j){
        changeSingleCellColor(i,j);
        changeSingleCellColor(i-1,j);
        changeSingleCellColor(i+1,j);
        changeSingleCellColor(i,j-1);
        changeSingleCellColor(i,j+1);
    }

    private void changeSingleCellColor(int i, int j) {
        try{
        colors[i][j]++;
        colors[i][j] %= 3; 
        } catch (ArrayIndexOutOfBoundsException aioobe){
        }
    }
    
    public boolean isGameWon(){
        int oneColor = colors[0][0];
        for (int i = 0; i < getWidth(); i++) {
            for (int j = 0; j < getHeight(); j++) {
                if(colors[i][j] != oneColor){
                    return false;
                }    
            }
        }
        return true;
    }
    
    
}
